freedombone-app-turtl 25KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # turtl app
  12. #
  13. # http://portallinux.es/instalacion-servidor-turtl-debian-8
  14. # http://framacloud.org/cultiver-son-jardin/installation-de-turtl/
  15. #
  16. # License
  17. # =======
  18. #
  19. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  20. #
  21. # This program is free software: you can redistribute it and/or modify
  22. # it under the terms of the GNU Affero General Public License as published by
  23. # the Free Software Foundation, either version 3 of the License, or
  24. # (at your option) any later version.
  25. #
  26. # This program is distributed in the hope that it will be useful,
  27. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  28. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  29. # GNU Affero General Public License for more details.
  30. #
  31. # You should have received a copy of the GNU Affero General Public License
  32. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  33. VARIANTS="full full-vim writer"
  34. IN_DEFAULT_INSTALL=0
  35. SHOW_ON_ABOUT=1
  36. TURTL_DOMAIN_NAME=
  37. TURTL_CODE=
  38. TURTL_ONION_PORT=8107
  39. TURTL_PORT=8181
  40. TURTL_REPO="https://github.com/turtl/api.git"
  41. TURTL_COMMIT='53e00a5583f52de8f86ef380fe11c176b5738dcf'
  42. TURTL_ADMIN_PASSWORD=
  43. TURTL_STORAGE_LIMIT_MB=100
  44. TURTL_BASE_DIR=/etc/turtl
  45. # part of a hack to enable/disable signups
  46. TURTL_SIGNUP_STRING='Signup a new user'
  47. turtl_users_file=$TURTL_BASE_DIR/api/controllers/users.lisp
  48. turtl_variables=(ONION_ONLY
  49. DEFAULT_DOMAIN_NAME
  50. TURTL_DOMAIN_NAME
  51. TURTL_CODE
  52. TURTL_STORAGE_LIMIT_MB
  53. DDNS_PROVIDER
  54. MY_EMAIL_ADDRESS
  55. MY_USERNAME)
  56. function change_password_turtl {
  57. change_username="$1"
  58. new_user_password="$2"
  59. }
  60. function remove_user_turtl {
  61. remove_username="$1"
  62. }
  63. function add_user_turtl {
  64. new_username="$1"
  65. new_user_password="$2"
  66. echo '0'
  67. }
  68. function install_interactive_turtl {
  69. if [ ! $ONION_ONLY ]; then
  70. ONION_ONLY='no'
  71. fi
  72. if [[ $ONION_ONLY != "no" ]]; then
  73. TURTL_DOMAIN_NAME='notes.local'
  74. write_config_param "TURTL_DOMAIN_NAME" "$TURTL_DOMAIN_NAME"
  75. else
  76. function_check interactive_site_details
  77. interactive_site_details "turtl" "TURTL_DOMAIN_NAME" "TURTL_CODE"
  78. fi
  79. APP_INSTALLED=1
  80. }
  81. function turtl_disable_registrations {
  82. if grep "$TURTL_SIGNUP_STRING" $turtl_users_file; then
  83. if [ -f $turtl_users_file ]; then
  84. cp $turtl_users_file $TURTL_BASE_DIR/.users.lisp
  85. sed -i '/(route (:post "\/users") (req res)/,/(send-json res user))))/{//!d}' $turtl_users_file
  86. sed -i 's|(send-json res user))))|())|g' $turtl_users_file
  87. chown -R turtl:turtl $TURTL_BASE_DIR
  88. systemctl restart turtl
  89. fi
  90. fi
  91. }
  92. function turtl_enable_registrations {
  93. if ! grep "$TURTL_SIGNUP_STRING" $turtl_users_file; then
  94. if [ -f $TURTL_BASE_DIR/.users.lisp ]; then
  95. cp $TURTL_BASE_DIR/.users.lisp $turtl_users_file
  96. rm $TURTL_BASE_DIR/.users.lisp
  97. chown -R turtl:turtl $TURTL_BASE_DIR
  98. systemctl restart turtl
  99. fi
  100. fi
  101. }
  102. function configure_interactive_turtl_signups {
  103. # This implements a hack which removes or adds the function needed
  104. # to sign up new users. It should eventually be removed once that
  105. # capability exists within the api
  106. dialog --title $"Allow new turtl signups" \
  107. --backtitle $"Freedombone Control Panel" \
  108. --defaultno \
  109. --yesno $"\nAllow registration of new users?" 10 60
  110. sel=$?
  111. case $sel in
  112. 0)
  113. turtl_enable_registrations
  114. dialog --title $"Allow new turtl signups" \
  115. --msgbox $"New turtl user registrations are now allowed" 6 60
  116. return;;
  117. 1)
  118. turtl_disable_registrations
  119. dialog --title $"Disable new turtl signups" \
  120. --msgbox $"New turtl user registrations are now disabled" 6 60
  121. return;;
  122. 255) return;;
  123. esac
  124. }
  125. function configure_interactive_turtl_storage {
  126. data=$(tempfile 2>/dev/null)
  127. trap "rm -f $data" 0 1 2 5 15
  128. dialog --title $"Change storage limit" \
  129. --backtitle $"Freedombone Control Panel" \
  130. --inputbox $"Enter a storage limit in megabytes." 8 75 "$TURTL_STORAGE_LIMIT_MB" 2>$data
  131. sel=$?
  132. case $sel in
  133. 0)
  134. STORAGE=$(<$data)
  135. if [ ${#STORAGE} -gt 0 ]; then
  136. TURTL_STORAGE_LIMIT_MB=$STORAGE
  137. sed -i "s|defparameter *default-storage-limit*.*|defparameter *default-storage-limit* ${TURTL_STORAGE_LIMIT_MB})|g" $TURTL_BASE_DIR/api/config/config.lisp
  138. systemctl restart turtl
  139. dialog --title $"Change storage limit" \
  140. --msgbox $"Storage limit changed to ${TURTL_STORAGE_LIMIT_MB}M" 6 50
  141. fi
  142. ;;
  143. esac
  144. }
  145. function configure_interactive_turtl {
  146. data=$(tempfile 2>/dev/null)
  147. trap "rm -f $data" 0 1 2 5 15
  148. dialog --backtitle $"Freedombone Control Panel" \
  149. --title $"turtl app settings" \
  150. --radiolist $"Choose an operation:" 12 70 3 \
  151. 1 $"Enable/disable new user registrations" off \
  152. 2 $"Change storage limit" off \
  153. 3 $"Exit" on 2> $data
  154. sel=$?
  155. case $sel in
  156. 1) exit 1;;
  157. 255) exit 1;;
  158. esac
  159. case $(cat $data) in
  160. 1) configure_interactive_turtl_signups;;
  161. 2) configure_interactive_turtl_storage;;
  162. 3) return;;
  163. esac
  164. }
  165. function reconfigure_turtl {
  166. if [ -d $TURTL_BASE_DIR/data ]; then
  167. rm -rf $TURTL_BASE_DIR/data/*
  168. fi
  169. }
  170. function upgrade_turtl {
  171. read_config_param "TURTL_DOMAIN_NAME"
  172. function_check set_repo_commit
  173. set_repo_commit $TURTL_BASE_DIR/api "turtl commit" "$TURTL_COMMIT" $TURTL_REPO
  174. # this is used as a crude way of disabling signups and so
  175. # should be superceded in future
  176. if [ -f $TURTL_BASE_DIR/.users.lisp ]; then
  177. turtl_disable_registrations
  178. fi
  179. systemctl restart turtl
  180. nginx_dissite $TURTL_DOMAIN_NAME
  181. chown -R turtl:turtl $TURTL_BASE_DIR
  182. nginx_ensite $TURTL_DOMAIN_NAME
  183. }
  184. function backup_local_turtl {
  185. read_config_param "TURTL_DOMAIN_NAME"
  186. source_directory=$TURTL_BASE_DIR
  187. if [ -d $source_directory ]; then
  188. dest_directory=turtl
  189. function_check suspend_site
  190. suspend_site ${TURTL_DOMAIN_NAME}
  191. function_check backup_directory_to_usb
  192. backup_directory_to_usb $source_directory $dest_directory
  193. function_check restart_site
  194. restart_site
  195. fi
  196. source_directory=/var/lib/rethinkdb
  197. if [ -d $source_directory ]; then
  198. dest_directory=rethinkdb
  199. function_check suspend_site
  200. suspend_site ${TURTL_DOMAIN_NAME}
  201. function_check backup_directory_to_usb
  202. backup_directory_to_usb $source_directory $dest_directory
  203. function_check restart_site
  204. restart_site
  205. fi
  206. }
  207. function restore_local_turtl {
  208. read_config_param "TURTL_DOMAIN_NAME"
  209. if [ $TURTL_DOMAIN_NAME ]; then
  210. temp_restore_dir=/root/tempturtl
  211. restore_directory_from_usb $temp_restore_dir turtl
  212. if [ -d $TURTL_BASE_DIR ]; then
  213. if [ -d /etc/turtl_previous ]; then
  214. rm -rf /etc/turtl_previous
  215. fi
  216. mv $TURTL_BASE_DIR /etc/turtl_previous
  217. fi
  218. temp_source_dir=$(find ${temp_restore_dir} -name turtl)
  219. cp -r ${temp_source_dir} /etc/
  220. if [ ! "$?" = "0" ]; then
  221. if [ -d /etc/turtl_previous ]; then
  222. mv /etc/turtl_previous $TURTL_BASE_DIR
  223. fi
  224. set_user_permissions
  225. backup_unmount_drive
  226. exit 36723
  227. fi
  228. rm -rf ${temp_restore_dir}
  229. chown -R turtl:turtl $TURTL_BASE_DIR
  230. temp_restore_dir=/root/temprethinkdb
  231. restore_directory_from_usb $temp_restore_dir rethinkdb
  232. if [ -d /var/lib/rethinkdb ]; then
  233. if [ -d /var/lib/previous_rethinkdb ]; then
  234. rm -rf /var/lib/previous_rethinkdb
  235. fi
  236. mv /var/lib/rethinkdb /var/lib/previous_rethinkdb
  237. fi
  238. temp_source_dir=$(find ${temp_restore_dir} -name rethinkdb)
  239. cp -r ${temp_source_dir} /var/lib/
  240. if [ ! "$?" = "0" ]; then
  241. if [ -d /var/lib/previous_rethinkdb ]; then
  242. mv /var/lib/previous_rethinkdb /var/lib/rethinkdb
  243. fi
  244. set_user_permissions
  245. backup_unmount_drive
  246. exit 378324
  247. fi
  248. rm -rf ${temp_restore_dir}
  249. fi
  250. }
  251. function backup_remote_turtl {
  252. read_config_param "TURTL_DOMAIN_NAME"
  253. if [ $TURTL_DOMAIN_NAME ]; then
  254. temp_backup_dir=$TURTL_BASE_DIR
  255. if [ -d $temp_backup_dir ]; then
  256. echo $"Backing up turtl"
  257. backup_directory_to_friend $temp_backup_dir turtl
  258. echo $"Backup of turtl complete"
  259. else
  260. echo $"turtl domain specified but not found in $temp_backup_dir"
  261. exit 68725
  262. fi
  263. temp_backup_dir=/var/lib/rethinkdb
  264. if [ -d $temp_backup_dir ]; then
  265. echo $"Backing up rethinkdb"
  266. backup_directory_to_friend $temp_backup_dir rethinkdb
  267. echo $"Backup of rethinkdb complete"
  268. fi
  269. fi
  270. }
  271. function restore_remote_turtl {
  272. read_config_param "TURTL_DOMAIN_NAME"
  273. if [ $TURTL_DOMAIN_NAME ]; then
  274. temp_restore_dir=/root/tempturtl
  275. mkdir $temp_restore_dir
  276. function_check restore_directory_from_friend
  277. restore_directory_from_friend $temp_restore_dir turtl
  278. if [ -d $TURTL_BASE_DIR ]; then
  279. if [ -d /etc/turtl_previous ]; then
  280. rm -rf /etc/turtl_previous
  281. fi
  282. mv $TURTL_BASE_DIR /etc/turtl_previous
  283. fi
  284. temp_source_dir=$(find ${temp_restore_dir} -name turtl)
  285. cp -r ${temp_source_dir} /etc/
  286. if [ ! "$?" = "0" ]; then
  287. if [ -d /etc/turtl_previous ]; then
  288. mv /etc/turtl_previous $TURTL_BASE_DIR
  289. fi
  290. exit 37823
  291. fi
  292. rm -rf ${temp_restore_dir}
  293. temp_restore_dir=/root/temprethinkdb
  294. mkdir $temp_restore_dir
  295. function_check restore_directory_from_friend
  296. restore_directory_from_friend $temp_restore_dir rethinkdb
  297. if [ -d /var/lib/rethinkdb ]; then
  298. if [ -d /var/lib/previous_rethinkdb ]; then
  299. rm -rf /var/lib/previous_rethinkdb
  300. fi
  301. mv /var/lib/rethinkdb /var/lib/previous_rethinkdb
  302. fi
  303. temp_source_dir=$(find ${temp_restore_dir} -name rethinkdb)
  304. cp -r ${temp_source_dir} /var/lib/
  305. if [ ! "$?" = "0" ]; then
  306. if [ -d /var/lib/previous_rethinkdb ]; then
  307. mv /var/lib/previous_rethinkdb /var/lib/rethinkdb
  308. fi
  309. exit 26783
  310. fi
  311. rm -rf ${temp_restore_dir}
  312. fi
  313. }
  314. function remove_turtl {
  315. if [ ! -d $TURTL_BASE_DIR ]; then
  316. return
  317. fi
  318. systemctl stop turtl
  319. systemctl disable turtl
  320. rm /etc/systemd/system/turtl.service
  321. systemctl daemon-reload
  322. remove_rethinkdb
  323. remove_app turtl
  324. remove_completion_param install_turtl
  325. sed -i '/turtl/d' $COMPLETION_FILE
  326. nginx_dissite $TURTL_DOMAIN_NAME
  327. if [ -f /etc/nginx/sites-available/$TURTL_DOMAIN_NAME ]; then
  328. rm /etc/nginx/sites-available/$TURTL_DOMAIN_NAME
  329. fi
  330. remove_certs $TURTL_DOMAIN_NAME
  331. function_check remove_onion_service
  332. remove_onion_service turtl ${TURTL_ONION_PORT}
  333. function_check remove_ddns_domain
  334. remove_ddns_domain $TURTL_DOMAIN_NAME
  335. rm -rf /etc/rethinkdb
  336. rm -rf /var/lib/rethinkdb
  337. rm -rf $TURTL_BASE_DIR
  338. groupdel -f turtl
  339. userdel -r turtl
  340. }
  341. function turtl_setup {
  342. PIDFILE=${PIDFILE:-nil}
  343. BINDADDR=${BINDADDR:-0.0.0.0}
  344. BINDPORT=${BINDPORT:-8181}
  345. PROD_ERR_HANDLING=${PROD_ERR_HANDLING:-t}
  346. if [[ $ONION_ONLY == 'no' ]]; then
  347. FQDN=${FQDN:-$TURTL_DOMAIN_NAME}
  348. SITE_URL=${SITE_URL:-https://$TURTL_DOMAIN_NAME}
  349. else
  350. FQDN=${FQDN:-$TURTL_ONION_HOSTNAME}
  351. SITE_URL=${SITE_URL:-http://$TURTL_ONION_HOSTNAME}
  352. fi
  353. ADMIN_EMAIL=${ADMIN_EMAIL:-$MY_EMAIL_ADDRESS}
  354. EMAIL_FROM=${EMAIL_FROM:-noreply@$DEFAULT_DOMAIN_NAME}
  355. SMTP_USER=${SMTP_USER:-}
  356. SMTP_PASS=${SMTP_PASS:-}
  357. DISPLAY_ERRORS=${DISPLAY_ERRORS:-t}
  358. DEFAULT_STORAGE_LIMIT=${DEFAULT_STORAGE_LIMIT:-100}
  359. STORAGE_INVITE_CREDIT=${STORAGE_INVITE_CREDIT:-25}
  360. if [[ $ONION_ONLY == 'no' ]]; then
  361. LOCAL_UPLOAD_URL=${LOCAL_UPLOAD_URL:-https://$TURTL_DOMAIN_NAME}
  362. else
  363. LOCAL_UPLOAD_URL=${LOCAL_UPLOAD_URL:-http://$TURTL_ONION_HOSTNAME}
  364. fi
  365. LOCAL_UPLOAD_PATH=${LOCAL_UPLOAD_PATH:-"$TURTL_BASE_DIR/data"}
  366. AWS_S3_TOKEN=${AWS_S3_TOKEN:-(:token ''
  367. :secret ''
  368. :bucket ''
  369. :endpoint 'https://s3.amazonaws.com')}
  370. # generates the config-file
  371. cat << __ENDCONFIG__ > $TURTL_BASE_DIR/api/config/config.lisp
  372. (in-package :turtl)
  373. (defparameter *root* (asdf:system-relative-pathname :turtl #P""))
  374. (defparameter *pid-file* "${PIDFILE}")
  375. (defvar *server-bind* "${BINDADDR}")
  376. (defvar *server-port* ${BINDPORT})
  377. (defvar *db-name* "turtl")
  378. (defvar *db-host* "127.0.0.1")
  379. (defvar *db-port* 28015)
  380. (defvar *production-error-handling* ${PROD_ERR_HANDLING})
  381. (defvar *enable-hsts-header* nil)
  382. (defvar *site-url* "${SITE_URL}")
  383. (defvar *api-path* "")
  384. (defvar *admin-email* "${ADMIN_EMAIL}")
  385. (defvar *email-from* "${EMAIL_FROM}")
  386. (defvar *email-user* "${SMTP_USER}")
  387. (defvar *email-pass* "${SMTP_PASS}")
  388. (defvar *display-errors* ${DISPLAY_ERRORS})
  389. (defparameter *default-storage-limit* ${DEFAULT_STORAGE_LIMIT})
  390. (defparameter *storage-invite-credit* ${STORAGE_INVITE_CREDIT})
  391. (vom:config :turtl :info)
  392. (defvar *local-upload* "${LOCAL_UPLOAD_PATH}")
  393. (defvar *local-upload-url* "${LOCAL_UPLOAD_URL}")
  394. (defvar *amazon-s3* "${AWS_S3_TOKEN}")
  395. __ENDCONFIG__
  396. cat $TURTL_BASE_DIR/api/config/config.footer >> $TURTL_BASE_DIR/api/config/config.lisp
  397. # start the turtl server
  398. systemctl restart rethinkdb
  399. echo '[Unit]' > /etc/systemd/system/turtl.service
  400. echo 'Description=Note taking service' >> /etc/systemd/system/turtl.service
  401. echo 'Documentation=http://turtl.it' >> /etc/systemd/system/turtl.service
  402. echo 'Requires=network.target' >> /etc/systemd/system/turtl.service
  403. echo 'Requires=rethinkdb.service' >> /etc/systemd/system/turtl.service
  404. echo 'After=network.target' >> /etc/systemd/system/turtl.service
  405. echo 'After=rethinkdb.service' >> /etc/systemd/system/turtl.service
  406. echo '' >> /etc/systemd/system/turtl.service
  407. echo '[Service]' >> /etc/systemd/system/turtl.service
  408. echo 'Type=simple' >> /etc/systemd/system/turtl.service
  409. echo 'User=turtl' >> /etc/systemd/system/turtl.service
  410. echo "WorkingDirectory=$TURTL_BASE_DIR/api/" >> /etc/systemd/system/turtl.service
  411. if [[ "$check_architecture" == *"64"* && "$check_architecture" != *"arm"* ]]; then
  412. echo "ExecStart=$TURTL_BASE_DIR/ccl/lx86cl64 -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  413. else
  414. if [[ "$check_architecture" != *"arm"* ]]; then
  415. echo "ExecStart=$TURTL_BASE_DIR/ccl/lx86cl -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  416. else
  417. echo "ExecStart=$TURTL_BASE_DIR/ccl/larmcl -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  418. fi
  419. fi
  420. echo '' >> /etc/systemd/system/turtl.service
  421. echo '[Install]' >> /etc/systemd/system/turtl.service
  422. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/turtl.service
  423. chmod +x /etc/systemd/system/turtl.service
  424. chown -R turtl:turtl $TURTL_BASE_DIR
  425. systemctl enable turtl
  426. systemctl daemon-reload
  427. systemctl start turtl
  428. }
  429. function install_turtl_api {
  430. # https://github.com/ArthurGarnier/turtl-docker
  431. apt-get -yq install wget libterm-readline-perl-perl gcc libuv1-dev
  432. if [ ! -d $TURTL_BASE_DIR ]; then
  433. mkdir -p $TURTL_BASE_DIR
  434. fi
  435. cd $TURTL_BASE_DIR
  436. mkdir cd $TURTL_BASE_DIR/data
  437. check_architecture=$(uname -a)
  438. # Install ccl
  439. if [[ "$check_architecture" != *"arm"* ]]; then
  440. wget -P $TURTL_BASE_DIR/ ftp://ftp.clozure.com/pub/release/1.11/ccl-1.11-linuxx86.tar.gz
  441. mkdir -p $TURTL_BASE_DIR/ccl
  442. tar xvzf $TURTL_BASE_DIR/ccl-1.11-linuxx86.tar.gz -C $TURTL_BASE_DIR/ccl --strip-components=1
  443. else
  444. wget -P $TURTL_BASE_DIR/ ftp://ftp.clozure.com/pub/release/1.11/ccl-1.11-linuxarm.tar.gz
  445. mkdir -p $TURTL_BASE_DIR/ccl
  446. tar xvzf $TURTL_BASE_DIR/ccl-1.11-linuxarm.tar.gz -C $TURTL_BASE_DIR/ccl --strip-components=1
  447. fi
  448. # install quicklisp
  449. cat << __ENDCONFIG__ > $TURTL_BASE_DIR/quicklisp_install
  450. (load (compile-file "asdf.lisp"))
  451. (load (compile-file "quicklisp.lisp"))
  452. (quicklisp-quickstart:install)
  453. (ql:system-apropos "vecto")
  454. (ql:quickload "alexandria")
  455. (ql:quickload "babel")
  456. (ql:quickload "blackbird")
  457. (ql:quickload "bordeaux-threads")
  458. (ql:quickload "cffi")
  459. (ql:quickload "chipz")
  460. (ql:quickload "chunga")
  461. (ql:quickload "cl-annot")
  462. (ql:quickload "cl-async")
  463. (ql:quickload "cl-async-future")
  464. (ql:quickload "cl-base64")
  465. (ql:quickload "cl-fad")
  466. (ql:quickload "cl-libuv")
  467. (ql:quickload "cl-mongo-id")
  468. (ql:quickload "cl-ppcre")
  469. (ql:quickload "cl-rethinkdb")
  470. (ql:quickload "cl-smtp")
  471. (ql:quickload "cl+ssl")
  472. (ql:quickload "cl-syntax")
  473. (ql:quickload "cl-utilities")
  474. (ql:quickload "cl-vectors")
  475. (ql:quickload "do-urlencode")
  476. (ql:quickload "drakma")
  477. (ql:quickload "drakma-async")
  478. (ql:quickload "event-glue")
  479. (ql:quickload "fast-http")
  480. (ql:quickload "fast-io")
  481. (ql:quickload "flexi-streams")
  482. (ql:quickload "ironclad")
  483. (ql:quickload "jonathan")
  484. (ql:quickload "local-time")
  485. (ql:quickload "md5")
  486. (ql:quickload "named-readtables")
  487. (ql:quickload "nibbles")
  488. (ql:quickload "proc-parse")
  489. (ql:quickload "puri")
  490. (ql:quickload "quri")
  491. (ql:quickload "salza2")
  492. (ql:quickload "secure-random")
  493. (ql:quickload "smart-buffer")
  494. (ql:quickload "split-sequence")
  495. (ql:quickload "static-vectors")
  496. (ql:quickload "trivial-backtrace")
  497. (ql:quickload "trivial-features")
  498. (ql:quickload "trivial-garbage")
  499. (ql:quickload "trivial-gray-streams")
  500. (ql:quickload "trivial-types")
  501. (ql:quickload "usocket")
  502. (ql:quickload "vecto")
  503. (ql:quickload "vom")
  504. (ql:quickload "wookie")
  505. (ql:quickload "xmls")
  506. (ql:quickload "xsubseq")
  507. (ql:quickload "yason")
  508. (ql:quickload "zpb-ttf")
  509. (ql:quickload "zpng")
  510. (ql:add-to-init-file)
  511. (ccl::quit)
  512. __ENDCONFIG__
  513. if [ ! -f asdf.lisp ]; then
  514. wget https://common-lisp.net/project/asdf/asdf.lisp
  515. fi
  516. if [ ! -f quicklisp.lisp ]; then
  517. wget https://beta.quicklisp.org/quicklisp.lisp
  518. fi
  519. adduser --disabled-login --home=$TURTL_BASE_DIR --gecos 'turtl' turtl
  520. if [ ! -d /home/turtl ]; then
  521. echo $"/home/turtl directory not created"
  522. exit 263493
  523. fi
  524. groupadd turtl
  525. chown -R turtl:turtl $TURTL_BASE_DIR
  526. if [[ "$check_architecture" != *"arm"* ]]; then
  527. if [[ "$check_architecture" == *"64"* ]]; then
  528. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/lx86cl64" - turtl
  529. else
  530. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/lx86cl" - turtl
  531. fi
  532. else
  533. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/larmcl" - turtl
  534. fi
  535. rm $TURTL_BASE_DIR/quicklisp_install
  536. install_rethinkdb
  537. echo "http-port=8091" > /etc/rethinkdb/instances.d/turtl.conf
  538. chown -R rethinkdb:rethinkdb /var/lib/rethinkdb
  539. # install turtl API
  540. cd $TURTL_BASE_DIR/
  541. git clone $TURTL_REPO $TURTL_BASE_DIR/api
  542. cd $TURTL_BASE_DIR/api
  543. git checkout $TURTL_COMMIT -b $TURTL_COMMIT
  544. set_completion_param "turtl commit" "$TURTL_COMMIT"
  545. cd $TURTL_BASE_DIR/quicklisp/local-projects
  546. git clone git://github.com/orthecreedence/cl-hash-util
  547. if [[ "$check_architecture" != *"arm"* ]]; then
  548. if [[ "$check_architecture" == *"64"* ]]; then
  549. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/lx86cl64 -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  550. else
  551. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/lx86cl -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  552. fi
  553. else
  554. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/larmcl -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  555. fi
  556. # config
  557. echo '(defvar *enabled-cors-resources* "resource://turtl-at-lyonbros-dot-com"' > $TURTL_BASE_DIR/api/config/config.footer
  558. echo ' "When set, will enable CORS for resource:// origins if they match the given' >> $TURTL_BASE_DIR/api/config/config.footer
  559. echo ' string. Entries should be comma separated (this string is passed verbatim in' >> $TURTL_BASE_DIR/api/config/config.footer
  560. echo ' the Access-Control-Allow-Origin header).")' >> $TURTL_BASE_DIR/api/config/config.footer
  561. echo '(defparameter *public-actions*' >> $TURTL_BASE_DIR/api/config/config.footer
  562. echo " \`((:post . ,(concatenate 'string *api-path* \"/users\"))" >> $TURTL_BASE_DIR/api/config/config.footer
  563. echo " (:post . ,(concatenate 'string *api-path* \"/log/error\"))" >> $TURTL_BASE_DIR/api/config/config.footer
  564. echo ' (:post . "/cla/sign")' >> $TURTL_BASE_DIR/api/config/config.footer
  565. echo ' (:get . "/ping")' >> $TURTL_BASE_DIR/api/config/config.footer
  566. echo ' (:get . "/admin")' >> $TURTL_BASE_DIR/api/config/config.footer
  567. echo " (:get . ,(cl-ppcre:create-scanner (concatenate 'string *api-path* \"/invites/codes/([0-9a-f-]+)\"))))" >> $TURTL_BASE_DIR/api/config/config.footer
  568. echo " \"A list of public resources/actions that do not require authentication.\")" >> $TURTL_BASE_DIR/api/config/config.footer
  569. echo "(defvar *analytics* '(:enabled t" >> $TURTL_BASE_DIR/api/config/config.footer
  570. echo ' :db "analytics"))' >> $TURTL_BASE_DIR/api/config/config.footer
  571. cp $TURTL_BASE_DIR/asdf.lisp $TURTL_BASE_DIR/api
  572. echo '(load (compile-file "asdf.lisp"))' > $TURTL_BASE_DIR/api/launch.lisp
  573. echo "(pushnew \"./\" asdf:*central-registry* :test #'equal)" >> $TURTL_BASE_DIR/api/launch.lisp
  574. echo '(load "start")' >> $TURTL_BASE_DIR/api/launch.lisp
  575. TURTL_ONION_HOSTNAME=$(add_onion_service turtl 80 ${TURTL_ONION_PORT})
  576. turtl_setup
  577. }
  578. function install_turtl_nginx {
  579. turtl_nginx_site=/etc/nginx/sites-available/$TURTL_DOMAIN_NAME
  580. if [[ $ONION_ONLY == "no" ]]; then
  581. function_check nginx_http_redirect
  582. nginx_http_redirect $TURTL_DOMAIN_NAME
  583. echo 'server {' >> $turtl_nginx_site
  584. echo ' listen 443 ssl;' >> $turtl_nginx_site
  585. echo ' listen [::]:443 ssl;' >> $turtl_nginx_site
  586. echo " server_name ${TURTL_DOMAIN_NAME};" >> $turtl_nginx_site
  587. echo '' >> $turtl_nginx_site
  588. echo ' # Security' >> $turtl_nginx_site
  589. function_check nginx_ssl
  590. nginx_ssl $TURTL_DOMAIN_NAME
  591. function_check nginx_disable_sniffing
  592. nginx_disable_sniffing $TURTL_DOMAIN_NAME
  593. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $turtl_nginx_site
  594. echo '' >> $turtl_nginx_site
  595. echo ' # Logs' >> $turtl_nginx_site
  596. echo ' access_log /dev/null;' >> $turtl_nginx_site
  597. echo ' error_log /dev/null;' >> $turtl_nginx_site
  598. echo '' >> $turtl_nginx_site
  599. echo ' location / {' >> $turtl_nginx_site
  600. function_check nginx_limits
  601. nginx_limits $TURTL_DOMAIN_NAME '15m'
  602. echo " proxy_pass http://localhost:${TURTL_PORT}/;" >> $turtl_nginx_site
  603. echo ' proxy_set_header Host $host;' >> $turtl_nginx_site
  604. echo ' proxy_buffering off;' >> $turtl_nginx_site
  605. echo ' }' >> $turtl_nginx_site
  606. echo '}' >> $turtl_nginx_site
  607. else
  608. echo -n '' > $turtl_nginx_site
  609. fi
  610. echo 'server {' >> $turtl_nginx_site
  611. echo " listen 127.0.0.1:${TURTL_ONION_PORT};" >> $turtl_nginx_site
  612. echo " server_name ${TURTL_ONION_HOSTNAME};" >> $turtl_nginx_site
  613. echo '' >> $turtl_nginx_site
  614. function_check nginx_disable_sniffing
  615. nginx_disable_sniffing $TURTL_DOMAIN_NAME
  616. echo '' >> $turtl_nginx_site
  617. echo ' # Logs' >> $turtl_nginx_site
  618. echo ' access_log /dev/null;' >> $turtl_nginx_site
  619. echo ' error_log /dev/null;' >> $turtl_nginx_site
  620. echo '' >> $turtl_nginx_site
  621. echo ' location / {' >> $turtl_nginx_site
  622. function_check nginx_limits
  623. nginx_limits $TURTL_DOMAIN_NAME '15m'
  624. echo " proxy_pass http://localhost:${TURTL_PORT}/;" >> $turtl_nginx_site
  625. echo ' proxy_set_header Host $host;' >> $turtl_nginx_site
  626. echo ' proxy_buffering off;' >> $turtl_nginx_site
  627. echo ' }' >> $turtl_nginx_site
  628. echo '}' >> $turtl_nginx_site
  629. function_check add_ddns_domain
  630. add_ddns_domain $TURTL_DOMAIN_NAME
  631. set_completion_param "turtl domain" "$TURTL_DOMAIN_NAME"
  632. function_check create_site_certificate
  633. create_site_certificate $TURTL_DOMAIN_NAME 'yes'
  634. function_check nginx_ensite
  635. nginx_ensite $TURTL_DOMAIN_NAME
  636. systemctl restart nginx
  637. }
  638. function install_turtl {
  639. install_turtl_api
  640. install_turtl_nginx
  641. APP_INSTALLED=1
  642. }